﻿//IPRINT.CS iprogram author nobumich harasawa
using System;
using System.Collections;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Printing;
using System.IO;
using System.Timers;
using System.Windows.Forms;
public class ic_form:Form
{
int version=1;
//=====================================================================
//************************( wndproc )**********************************
//=====================================================================
string[] help_sx={
"IPRINTW.EXE {REAL,TEST,TEST_DATA} データ レイアウト 開始 終了",
"文字，罫線，バーコード(code39,jan)を紙に印刷するためのプログラムです。",
"◎'TEST'の時は印刷情報を画面に表示します。",
"◎'TEST_DATA'の時はデータを読まないで自動的に作り出します。",
"　マウス右ボタンのPrintで１頁分のテスト印刷をします。",
"　Enterキーで次のページを表示し，Escキーで終了します。",
"　→,←,↑,↓,で画面内を移動し,Inset,Delete,Home,Endで拡大縮小します。",
"　線幅が異なっても解像度の問題で画面で幅が変わって見えない時は拡大して下さい。",
"◎'REAL'の時は実際に印刷します。",
"◎データが空の時は'IPRINT.TXT'と見なします。",
"　データでそれぞれの印刷データをタブで区切って指定します。",
"　１ページ分のデータの終わりがレコードの切れ目と合わない場合エラーになります。",
"◎レイアウトが空の時は'IPRINT.CSV'と見なします。",
"　レイアウトで印刷レイアウトをＣＳＶ形式で指定します。",
"　先頭に'*'の有るレコードは注釈とみなします。",
"　最後に'\\'の有るレコードは継続します。",
"　文字列が空の時はデータより文字列を読み込みます。",
"　ｘは右方向，ｙは下方向のオフセットの位置を表します。",
"　位置，高，幅は１ｍｍ単位で指定し小数点以下も指定できます。",
"　線種は以下の指定ができます。",
"　（０＝実線，１＝破線、２＝点線、３＝１点破線、４＝２点破線）",
"　数値項目を省略した場合は０と見なします。",
"　くり返し項目が０のときは以降くり返し無しと見なします。",
"●用紙を指定 PAPER,用紙サイズ,印刷の向き",
"             用紙サイズはA4,B5等プリンタで指定可能な物です,空は既定値です。",
"             印刷の向きは１が縦向きで、２が横向きです、空は既定値です。",
"●オフセット情報を指定 OFFSET,x,y[,x以降くり返し]。",
"●線名を指定    LINE_SET,線名,線幅,線種,線名以降くり返し",
"●文字名を指定  CHAR_SET,文字名,文字サイズ,フォント,属性,文字名以降くり返し",
"                     属性は'B'が太字で、'I'が斜体です、'BI'が太字で斜体です",
"◎以下は繰り返し指定出来ます。",
"●繰り返し指定    OCCURS,繰り返し数,ｘ,ｙ,繰り返し数以降くり返し",
"                  （ｘ,ｙはオフセット位置です、次のoccurs指定まで有効です）",
"●任意の線を引く   LINE,線名,x1,y1,x2,y2[,x1以降くり返し]",
"●長方形の線を引く BOX,線名,x1,y1,x2,y2[,x1以降くり返し]",
"●横の線を引く     X_LINE,線名,x1,y,x2[,yのくり返し]",
"●縦の線を引く     Y_LINE,線名,x,y1,y2[,xのくり返し]",
"●楕円を引く       ARC,線名,x1,y1,x2,y2,開始角度,終了角度[,x1以降のくり返し]",
"●文字を印字       TEXT,文字列,文字名,[文字間隔],x,y,文字数,編集[,文字名以降くり返し]",
"      文字数が０の時は文字列より文字数を計算します)",
"      (編集はRは右詰め,Dは日付け(YYYY-MM-DD),-,+,.は数値で','を付加して右詰め、",
"      Zは単に右詰めしますがZと．は少数点以下が０の時は．以下を印字しません",
"      Yは日付けを日月年の順番（DD-MM-YYYY)で表示します）",
"●データを印字     DATA,文字名,[文字間隔],x,y,文字数,編集[,文字名以降くり返し]",
"●CODE39を印字 CODE39,[文字列],細線幅,ｺｰﾄﾞ縦,x,y,文字ｻｲｽﾞ,x,y[,細線幅以降くり返]",
"               (文字ｘと文字ｙはバーコード印字左下位置からのオフセット位置です）",
"               (文字列の最初と最後に'*'が無い場合はデジット文字と*を付加します）",
"               (文字列にバーコード変換不可能文字が有るとエラー終了します）",
"               (文字列が空白の場合データから設定します）",
"●JANを印字する JAN,[文字列],細線幅,ｺｰﾄﾞ縦,x,y[,細線幅以降くり返し]",
"                (８文字か１３文字以外印字出来ません）",
"                (文字はOCR-Bフォントではありません）",
"                (７文字か１２文字の時はデジット文字を付加します）",
" 　             (文字列が空白の場合データから設定します）",
"●VERSIONを判定 VERSION,バージョン番号",
"◎開始は開始頁を指定します、省略又は０の時は１頁目の指定です。",
"◎終了は終了頁を指定します、省略又は０の時は最後の頁の指定です。",
"○用紙の種類は該当プリンタの指定可能なもののみ使用下さい。"};
int bb,ss,dd,i,j,k,l,m,m_max,m_xx,/*m2_xx,*/m_yy/*,m2_yy,n*/,jan_pt_no,jan_0,jan_1,jan_2
  ,jan_3,sw_txt=0,control=0,kk,test_data_no=0,start_cnt=1,/*cnt=0,*/stop_cnt=0
  ,page_cnt=1,data_max=0,data_cnt=0,sw_data_end=0,char_occurs_start=-1
  ,line_occurs_start=-1,rc,count,max,sw_error=0,sw_fin=0,sw_continue=0
  ,REAL=3,TEST=2,TEST_DATA=1;
float f,mm,xx,yy,x1,x2,y1,y2,xxx,yyy,Ritu=1,xOf=0,yOf=0,pos,nxt,short_bar
   ,short_bar2,short_bar3,short_space
   ,long_bar,long_bar2,long_bar3,long_space;
float[] jan_e_fx=new float[2],jan_b_fx=new float[2];
string doc_s,layout_file_s="IPRINT.CSV",paper_size_s="",paper_hv_s=""
  ,txt_file_s="IPRINT.TXT",read_s,default_font_s="MS Gothic"
  ,code39_mozi="1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%";
string[] data_sx;
int[,] code39_bar_ixx={{0,0,0,0,0}
    ,{1,0,0,0,1},{0,1,0,0,1},{1,1,0,0,0},{0,0,1,0,1},{1,0,1,0,0},
     {0,1,1,0,0},{0,0,0,1,1},{1,0,0,1,0},{0,1,0,1,0},{0,0,1,1,0},{0,0,0,0,0}}
 ,code39_space_ixx={{1,1,1,0,0},{1,1,0,1,0},{1,0,1,1,0},{0,1,1,1,0}
         ,{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{1,0,0,0,0}}
 ,jan_bar={{3,2,1,1},{2,2,2,1},{2,1,2,2},{1,4,1,1},{1,1,3,2},
        {1,2,3,1},{1,1,1,4},{1,3,1,2},{1,2,1,3},{3,1,1,2}}
 ,jan_pt={{1,1,1,1,1,1},{1,1,0,1,0,0},{1,1,0,0,1,0},{1,1,0,0,0,1},
     {1,0,1,1,0,0},{1,0,0,1,1,0},{1,0,0,0,1,1},{1,0,1,0,1,0},{1,0,1,0,0,1},
     {1,0,0,1,0,1}};
Font font_o;Pen pen_o;Brush solid_brush_o;
ArrayList char_name_a=new ArrayList(),char_size_a=new ArrayList()
  ,char_font_a=new ArrayList(),char_kind_a=new ArrayList()
  ,line_name_a=new ArrayList(),line_size_a=new ArrayList()
  ,line_kind_a=new ArrayList(),pen_a=new ArrayList()
  ,offset_a=new ArrayList(),occurs_a=new ArrayList(),s_a=new ArrayList()
  ,in_a=new ArrayList(),out_a=new ArrayList(),char_a=new ArrayList()
  ,line_a=new ArrayList();
ic_z z=new ic_z();
ic_read read_o;
int sw_read=0;
//****( Printer Seting begin )*************************
ic_form(string[] i_arg_sx)
{read_o=new ic_read(z);
Text="IPRINT VERSION="+version;
solid_brush_o=new SolidBrush(Color.Black);
font_o=new Font(default_font_s,4,FontStyle.Regular,GraphicsUnit.Millimeter);
ClientSize=new Size(font_o.Height*35,font_o.Height*35);
BackColor=SystemColors.Window;
char_name_a.Add("");char_size_a.Add((float)3.5);
char_font_a.Add(default_font_s);char_kind_a.Add("");
i=0;
if(i_arg_sx.Length>0)
  if     (i_arg_sx[0].ToUpper()=="REAL")control=REAL;
  else if(i_arg_sx[0].ToUpper()=="TEST")control=TEST;
  else if(i_arg_sx[0].ToUpper()=="TEST_DATA")control=TEST_DATA;
if(i_arg_sx.Length>1)txt_file_s=i_arg_sx[1];
if(i_arg_sx.Length>2)layout_file_s=i_arg_sx[2];
if(i_arg_sx.Length>3)if(!to_int(ref start_cnt,i_arg_sx[3]))goto err;
if(i_arg_sx.Length>4)if(!to_int(ref stop_cnt,i_arg_sx[4]))goto err;
if(1>start_cnt){z.err_s="start page("+start_cnt+") error";goto err;}
if(0>stop_cnt||0!=stop_cnt&&stop_cnt<start_cnt)
 {z.err_s="stop page("+stop_cnt+") error";goto err;}
if(-1==(i=txt_file_s.LastIndexOf('\\')))i=0;
doc_s=txt_file_s.Substring(i);
ip_context_menu();
KeyDown+=new KeyEventHandler(keydown);
if(0==control)
 {paper_size_s="A4";paper_hv_s="1";char_a.Clear();
  for(i=0;help_sx.Length>i;i++)
   {out_a=new ArrayList();out_a.Add("TEXT");out_a.Add(help_sx[i]);
    out_a.Add(new ArrayList());out_a.Add("");out_a.Add((float)0);out_a.Add((float)0);
    out_a.Add((float)(i*3.5));out_a.Add((int)0);out_a.Add("");
    char_a.Add(out_a);
   }
   offset_a.Add((float)0);offset_a.Add((float)0);
   return;
  }
if(0!=read_o.open(layout_file_s,""))goto err;
layout_loop:
if(0!=sw_read)goto layout_fin;
read_s="";
layout_read:
if(0!=(rc=read_o.read()))if(1==rc)sw_read=1;else goto err;
else if(read_o.data_s.Length>0&&'\\'==read_o.data_s[read_o.data_s.Length-1])
   {read_s+=read_o.data_s.Substring(0,read_o.data_s.Length-1).TrimStart();
    goto layout_read;
   }
  else read_s+=read_o.data_s.TrimStart();
if(""==read_s||read_s.Length>0&&'*'==read_s[0])goto layout_loop;
csv_split(ref s_a,read_s);
if(0==s_a.Count)goto layout_loop;
out_a=new ArrayList();count=4;
switch(((string)s_a[0]).ToUpper())
 {case "DATA":
    for(;s_a.Count<7||0!=((s_a.Count-1)%6);)s_a.Add("");
    out_a.Add(s_a[0]);out_a.Add("");out_a.Add(new ArrayList());
    data_max++;
    for(i=1;s_a.Count>i;i+=6)
     {if(-1==(j=char_name_a.IndexOf(s_a[i])))
           {z.err_s="char name("+s_a[i]+") not found";goto layout_err;}
        out_a.Add(char_name_a[j]);
       if(!to_float(ref f,(string)s_a[i+1]))goto layout_err;
       out_a.Add(f);
       if(!to_float(ref f,(string)s_a[i+2]))goto layout_err;
       out_a.Add(f);
       if(!to_float(ref f,(string)s_a[i+3]))goto layout_err;
       out_a.Add(f);
       if(!to_int(ref j,(string)s_a[i+4]))goto layout_err;
       out_a.Add(j);
       out_a.Add(s_a[i+5]);
      }
    char_a.Add(out_a);
    goto layout_loop;
  case "TEXT":
    for(;s_a.Count<8||0!=((s_a.Count-2)%6);)s_a.Add("");
    out_a.Add(s_a[0]);out_a.Add(s_a[1]);out_a.Add(new ArrayList());
    for(i=2;s_a.Count>i;i+=6)
     {if(-1==(j=char_name_a.IndexOf(s_a[i])))
           {z.err_s="char name("+s_a[i]+") not found";goto layout_err;}
        out_a.Add(char_name_a[j]);
       if(!to_float(ref f,(string)s_a[i+1]))goto layout_err;
       out_a.Add(f);
       if(!to_float(ref f,(string)s_a[i+2]))goto layout_err;
       out_a.Add(f);
       if(!to_float(ref f,(string)s_a[i+3]))goto layout_err;
       out_a.Add(f);
       if(!to_int(ref j,(string)s_a[i+4]))goto layout_err;
       out_a.Add(j);
       out_a.Add(s_a[i+5]);
      }
    char_a.Add(out_a);
    goto layout_loop;
  case "CODE39":
    for(;s_a.Count<9;)s_a.Add("");
    out_a.Add(s_a[0]);out_a.Add(s_a[1]);out_a.Add(new ArrayList());
    if(""==(string)s_a[1])data_max++;
    if(!to_float(out_a,2,7))goto layout_err;
    char_a.Add(out_a);
    goto layout_loop;
  case "JAN":
    for(;s_a.Count<6;)s_a.Add("");
    out_a.Add(s_a[0]);out_a.Add(s_a[1]);out_a.Add(new ArrayList());
    if(""==(string)s_a[1])data_max++;
    if(!to_float(out_a,2,4))goto layout_err;
    char_a.Add(out_a);
    goto layout_loop;
  case "X_LINE":count=3;goto case "BOX";
  case "Y_LINE":count=3;goto case "BOX";
  case "LINE":count=4;goto case "BOX";
  case "ARC":count=6;goto case "BOX";
  case "BOX":
    for(;s_a.Count<(2+count);)s_a.Add("");
    out_a.Add(s_a[0]);
    if(-1==(j=line_name_a.IndexOf(s_a[1])))
           {z.err_s="line name("+s_a[1]+") not found";goto layout_err;}
    out_a.Add(line_name_a[j]);
    if(!to_float(out_a,2,0))goto layout_err;
    line_a.Add(out_a);
    goto layout_loop;
  case "OCCURS":occurs();
        line_occurs_start=line_a.Count;
        char_occurs_start=char_a.Count;
        for(i=1;s_a.Count>j;j+=3)
         {if(!to_int(ref j,(string)s_a[i]))goto layout_err;
          occurs_a.Add(j);
          if(!to_float(ref f,(string)s_a[i+1]))goto layout_err;
          occurs_a.Add(f);
          if(!to_float(ref f,(string)s_a[i+2]))goto layout_err;
          occurs_a.Add(f);
         }
        goto layout_loop;
  case "LINE_SET":
    for(;0!=(s_a.Count-1)%3;)s_a.Add("");
    for(i=1;s_a.Count>i;i+=3)
     {line_name_a.Add(s_a[i]);
      if(!to_float(ref f,(string)s_a[i+1]))goto layout_err;
      line_size_a.Add(zero_float(f));
      line_kind_a.Add(s_a[i+2]);
     }
    goto layout_loop;
  case "CHAR_SET":
    for(;0!=(s_a.Count-1)%4;)s_a.Add("");
    for(i=1;s_a.Count>i;i+=4)
     {char_name_a.Add(s_a[i]);
      if(!to_float(ref f,(string)s_a[i+1]))goto layout_err;
      char_size_a.Add(zero_float(f));
      char_font_a.Add(s_a[i+2]);
      char_kind_a.Add(s_a[i+3]);
     }
   goto layout_loop;
  case "OFFSET":if(!to_float(offset_a,1,2))goto layout_err;
    goto layout_loop;
  case "PAPER":
   if(2!=s_a.Count&&3!=s_a.Count)goto layout_err_count;
    paper_size_s=(string)s_a[1];
    if(3==s_a.Count)paper_hv_s=(string)s_a[2];
    goto layout_loop;
 case "VERSION":
       if(2!=s_a.Count)goto layout_err_count;
       if(!to_int(ref j,(string)s_a[1]))goto layout_err;
       if(version<j){z.err_s="version "+version+" < "+j+" NG";goto err;}
    goto layout_loop;
   default:break;
 }
goto layout_err;
layout_fin:
occurs();
if(0==offset_a.Count){offset_a.Add((float)0);offset_a.Add((float)0);}
data_max*=offset_a.Count/2;
read_o.close();
if(TEST_DATA==control)return;
if(0!=read_o.open(txt_file_s,""))goto err;
//================( print start )=========================
data_read0:
i=0;
data_read:
if(!read())goto err;
if(1==sw_data_end){z.err_s="Start Page Over";goto err;}
if(page_cnt<start_cnt)
 {i+=data_sx.Length;
  if(data_max>i)goto data_read;
  if(data_max<i){z.err_s="Page End data Count Error";goto err;}
  page_cnt++;
  goto data_read0;
 }
return;
//***************************************************************************
layout_err_count:
z.err_s="Count("+s_a.Count+")";
layout_err:
err:
if(0==sw_error)sw_error=1;
return;
}
//=====( occurs )=====
void occurs()
{if(occurs_a.Count>0)
  {max=line_a.Count;
   for(xx=yy=i=0;i<occurs_a.Count;i+=3)
   for(j=0;(int)occurs_a[i]>j;j++)
    {xx+=(float)occurs_a[i+1];yy+=(float)occurs_a[i+2];
     for(k=line_occurs_start;k<max;k++)
      {in_a=(ArrayList)line_a[k];out_a=new ArrayList();l=0;
       out_a.Add(in_a[l++]);out_a.Add(in_a[l++]);
       line_loop:
       out_a.Add((float)in_a[l++]+xx);out_a.Add((float)in_a[l++]+yy);
       if("Y_LINE"==(string)in_a[0])out_a.Add((float)in_a[l++]+yy);
       else
        {out_a.Add((float)in_a[l++]+xx);
         if(z.equal((string)in_a[0],"BOX","LINE","ARC"))
          {out_a.Add((float)in_a[l++]+yy);
          if("ARC"==(string)in_a[0])
             {out_a.Add((float)in_a[l++]);out_a.Add((float)in_a[l++]);}
           if(in_a.Count>(l+1))goto line_loop;
           line_a.Add(out_a);
           continue;
          }
        }
       if("Y_LINE"==(string)in_a[0])mm=xx;else mm=yy;
       for(;in_a.Count>l;l++)out_a.Add((float)in_a[l++]+mm);
       line_a.Add(out_a);
      }
    }
   max=char_a.Count;
   for(xx=yy=0,i=0;occurs_a.Count>i;i+=3)
   for(j=0;(int)occurs_a[i]>j;j++)
    {xx+=(float)occurs_a[i+1];yy+=(float)occurs_a[i+2];
     for(k=char_occurs_start;k<max;k++)
      {in_a=(ArrayList)char_a[k];out_a=new ArrayList();
       out_a.Add(in_a[0]);out_a.Add(in_a[1]);out_a.Add(in_a[2]);
       if(""==(string)in_a[1])data_max++;
       m_max=(""==(string)in_a[0]?5:"CODE39"==(string)in_a[0]?7:4);
       m_xx=(""==(string)in_a[0]?1:2);
       m_yy=(""==(string)in_a[0]?2:3);
       for(l=3;l<in_a.Count;)
       for(m=0;m_max>m;m++)
         if     (m_xx==m)out_a.Add((float)in_a[l++]+xx);
         else if(m_yy==m)out_a.Add((float)in_a[l++]+yy);
         else out_a.Add(in_a[l++]);
       char_a.Add(out_a);
      }
    }
  }
occurs_a.Clear();
}
//=====( bool read )=====
bool read()
{int rc;
 if(0==sw_data_end)
  if(0!=(rc=read_o.read()))
    if(1==rc)sw_data_end=1;else return false;
    else data_sx=read_o.data_s.Split('\t');
data_cnt=0;
return true;
}
bool printer()
{int sw=0;
Console.WriteLine("printer");
try{PrintDocument pd_o=new PrintDocument(); 
    pd_o.PrintPage+=new PrintPageEventHandler(print);
    pd_o.DocumentName=doc_s;
    if(""!=paper_size_s)
     {foreach(PaperSize paper_size in pd_o.PrinterSettings.PaperSizes)
        if(0==string.Compare(paper_size_s,paper_size.PaperName,true))
          {pd_o.DefaultPageSettings.PaperSize=paper_size;sw=1;break;}
      if(0==sw){z.err_s="PaperSize("+paper_size_s+") not found";return false;}
     } 
    if     ("1"==paper_hv_s)pd_o.DefaultPageSettings.Landscape=false;
    else if("2"==paper_hv_s)pd_o.DefaultPageSettings.Landscape=true;
    pd_o.Print();
   }
catch(Exception e){z.err_s=e.Message;return false;}
if(0!=sw_error)return false;
return true;
}
//=====( print )=====
void print(object i_o, PrintPageEventArgs i_v)
{if(0!=data_cnt){z.err_s="Page End data Count("+data_max+") Error";goto err;}
if(!print(i_v.Graphics,0,0,1,sw_txt))goto err;
if(REAL!=control){sw_txt=1;goto fin;}
page_cnt++;
if(0!=stop_cnt&&page_cnt>stop_cnt||0==data_max)sw_data_end=1;
if(0!=sw_data_end)goto fin;else i_v.HasMorePages=true;
return;
err:sw_error=1;
i_v.Cancel=true;
fin:
i_v.HasMorePages=false;
return;
}
bool print(Graphics i_g,float i_xx,float i_yy,float i_ritu,int i_sw)
{int i;
i_g.PageUnit=GraphicsUnit.Millimeter;
for(i=0;offset_a.Count>i;i+=2)
 {if(!print_sub(i_g,i/2,i_xx+(float)offset_a[i],i_yy+(float)offset_a[i+1]
  ,i_ritu,i_sw))return false;
 if(1==sw_data_end)return true;
 }
return true;
}
//=====( print_sub )=====
bool print_sub(Graphics i_g,int i_i,float i_xx,float i_yy,float i_ritu,int i_sw)
{int i,j,k;string s;float f;
foreach(ArrayList a in line_a)
 {out_a=(ArrayList)a;
  k=line_name_a.IndexOf((string)out_a[1]);
  f=(float)line_size_a[k]*i_ritu;
  if(0==f)f=0.1f;
  pen_o=new Pen(solid_brush_o,f);
  if     ("1"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.Dash;
  else if("2"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.Dot;
  else if("3"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.DashDot;
  else if("4"==(string)line_kind_a[k])pen_o.DashStyle=DashStyle.DashDotDot;
  if("X_LINE"==(string)out_a[0])
   {x1=(i_xx+(float)out_a[2])*i_ritu;
    y1=(i_yy+(float)out_a[3])*i_ritu;
    x2=(i_xx+(float)out_a[4])*i_ritu;i_g.DrawLine(pen_o,x1,y1,x2,y1);
    for(i=5;out_a.Count>i;i++)
      {y1=(i_yy+(float)out_a[i])*i_ritu;i_g.DrawLine(pen_o,x1,y1,x2,y1);}
   }
  else if("Y_LINE"==(string)out_a[0])
     {x1=(i_xx+(float)out_a[2])*i_ritu;
      y1=(i_yy+(float)out_a[3])*i_ritu;
      y2=(i_yy+(float)out_a[4])*i_ritu;i_g.DrawLine(pen_o,x1,y1,x1,y2);
      for(i=5;out_a.Count>i;i++)
       {x1=(i_xx+(float)out_a[i])*i_ritu;i_g.DrawLine(pen_o,x1,y1,x1,y2);}
     }
  else if("ARC"==(string)out_a[0])
    for(i=2;out_a.Count>i;i+=6)
     {x1=(i_xx+(float)out_a[i])*i_ritu;
      y1=(i_yy+(float)out_a[i+1])*i_ritu;
      x2=(i_xx+(float)out_a[i+2])*i_ritu;
      y2=(i_yy+(float)out_a[i+3])*i_ritu;
      i_g.DrawArc(pen_o,(x1<x2?x1:x2),(y1<y2?y1:y2)
       ,(x1>x2?x1-x2:x2-x1),(y1>y2?y1-y2:y2-y1)
       ,((float)out_a[i+4]),((float)out_a[i+5]));
     }
 else  for(i=2;out_a.Count>i;i+=4)
     {x1=(i_xx+(float)out_a[i])*i_ritu;
      y1=(i_yy+(float)out_a[i+1])*i_ritu;
      x2=(i_xx+(float)out_a[i+2])*i_ritu;
      y2=(i_yy+(float)out_a[i+3])*i_ritu;
      if("BOX"==(string)out_a[0])
       i_g.DrawRectangle(pen_o,(x1<x2?x1:x2),(y1<y2?y1:y2)
       ,(x1>x2?x1-x2:x2-x1),(y1>y2?y1-y2:y2-y1));
      else i_g.DrawLine(pen_o,x1,y1,x2,y2);
     }
 }
foreach(ArrayList a in char_a)
 {out_a=a;
  if(""!=(string)out_a[1])s=(string)out_a[1];
  else if(0!=i_sw)s=(string)((ArrayList)out_a[2])[i_i];
  else
   {if(TEST_DATA==control)
     {if(10==++test_data_no)test_data_no=0;s=""+test_data_no;}
    else 
      if(0==sw_data_end)
       {s=data_sx[data_cnt];if(data_sx.Length<=++data_cnt)read();}
      else s="";
    ((ArrayList)out_a[2]).Add(s);
   }
  for(i=3;out_a.Count>i;)
   {if(z.equal((string)out_a[0],"TEXT","DATA"))
     {if(z.equal((string)out_a[i+5],"+","-",".")&&0<(int)out_a[i+4])
       {if(TEST_DATA==control)
          s=s.PadRight((int)out_a[i+4]-(int)out_a[i+4]/4,s[0]);
        s=z.comma(s);
        s=s.PadLeft((int)out_a[i+4]);
      }
      else if(z.equal((string)out_a[i+5],"R","Z")) //rigth
       {if(0!=(int)out_a[i+4])s=s.PadLeft((int)out_a[i+4]);}
      else if("D"==(string)out_a[i+5])
       {if(TEST_DATA==control)s=s.PadRight(8,s[0]);
        if(s.Length==8)s=""+s[0]+s[1]+s[2]+s[3]+"-"+s[4]+s[5]+"-"+s[6]+s[7];
       }
      else if("Y"==(string)out_a[i+5])
       {if(TEST_DATA==control)s=s.PadRight(8,s[0]);
        if(s.Length==8)s=""+s[6]+s[7]+"-"+s[4]+s[5]+"-"+s[0]+s[1]+s[2]+s[3];
       }
      else if(TEST_DATA==control)s=s.PadRight((int)out_a[i+4],s[0]);
      if(z.equal((string)out_a[i+5],".","Z")) //.00 空白変換
        for(j=s.Length-1;0<j;j--)
          if('0'==s[j])continue;else if('.'==s[j])s=s.Substring(0,j);else break;
      k=char_name_a.IndexOf(out_a[3]);
      font_o=new Font((string)char_font_a[k],(float)char_size_a[k]*i_ritu
          ,(-1!=((string)char_kind_a[k]).ToLower().IndexOf('b')
           ?FontStyle.Bold:FontStyle.Regular)
           |(-1!=((string)char_kind_a[k]).ToLower().IndexOf('i')
           ?FontStyle.Italic:FontStyle.Regular),GraphicsUnit.Millimeter);
      if(0<(int)out_a[i+4])s=s.PadRight((int)out_a[i+4]);
      z.draw_string(i_g,(float)out_a[i+1],s,font_o,Brushes.Black
      ,(i_xx+(float)out_a[i+2])*i_ritu,(i_yy+(float)out_a[i+3])*i_ritu);
      i+=6;
     }
    else if("CODE39"==(string)out_a[0])
       {if(!code39(i_g,i_xx,i_yy,i_ritu,s,i))return false;i+=7;}
    else if("JAN"==(string)out_a[0])
       {if(!jan(i_g,i_xx,i_yy,i_ritu,s,i))return false;i+=4;}
   }
 }
return true;
}
//=====( keydown )=====
void keydown(object sender,KeyEventArgs e)
{if(REAL==control)return;
switch(e.KeyCode)
 {case Keys.Home: Ritu=1;xx=yOf=0;break;
  case Keys.End:  Ritu=1;break;
  case Keys.Enter:sw_txt=0;
    if(1==sw_data_end)
     {sw_data_end=0;read_o.close();
      if(0!=read_o.open(txt_file_s,""))sw_error=1;
      if(!read())sw_error=1;
     }
  break;
  case Keys.Up:   if(0>yOf)yOf+=(10/Ritu);break;
  case Keys.Down: yOf-=(10/Ritu);break;
  case Keys.Left: if(0>xOf)xOf+=(10/Ritu);break;
  case Keys.Right:xOf-=(10/Ritu);break;
  case Keys.Insert:Ritu+=(float)0.1;break;
  case Keys.Delete:if(Ritu>0.2)Ritu-=(float)0.1;break;
  case Keys.Escape:Close();return;
  default:return;
 }
Refresh();
}
protected override void OnPaint(PaintEventArgs p)
{loop:
if(1==sw_continue)return;
if(1==sw_error){sw_error=2;err();sw_fin=1;}
if(1==sw_fin){read_o.close();Close();return;}
sw_continue=1;
if(0==sw_error&&0==sw_fin)
  if(REAL==control)
    {if(!printer())sw_error=1;else sw_fin=1;sw_continue=0;goto loop;}
  else if(!print(p.Graphics,xOf,yOf,Ritu,sw_txt)){sw_error=1;sw_continue=0;goto loop;}
sw_txt=1;
sw_continue=0;
}
void err()
{z.beep();
MessageBox.Show(z.err_s+Environment.NewLine+read_s,"IPRINT"
,MessageBoxButtons.OK);
}
void menu1(Object i_o,EventArgs i_e){if(REAL!=control)if(!printer())err();}
//=====( Context Mneu )=====
void ip_context_menu()
{ContextMenu m0=new ContextMenu();MenuItem m1=new MenuItem();
m1.Text="Print";m1.Click+=new EventHandler(menu1);
m0.MenuItems.Add(m1);ContextMenu=m0;
}
//*******************( code39 )********************************
bool code39(Graphics i_g,float i_xx,float i_yy,float i_ritu,string i_s,int i_i)
{int divi,rem;
//if(TEST_DATA==control)i_s=i_s.PadRight(7,i_s[0]);
if(i_s.Length>0&&('*'!=i_s[0]||'*'!=i_s[i_s.Length-1]))
   i_s="*"+i_s+z.code39(i_s)+"*";
short_space=short_bar=zero_float((float)out_a[i_i])*i_ritu;
short_bar2=short_bar/2;
short_bar3=short_bar-short_bar2;
long_space=long_bar=short_space*(float)2.5f;
long_bar2=long_bar/2;
long_bar3=long_bar-long_bar2;
pen_a.Clear();
pen_a.Add(new Pen(solid_brush_o,short_bar));
pen_a.Add(new Pen(solid_brush_o,long_bar));
x1=((float)out_a[i_i+2]+i_xx)*i_ritu;
y1=((float)out_a[i_i+3]+i_yy)*i_ritu;
y2=((float)out_a[i_i+3]+zero_float((float)out_a[i_i+1])+i_yy)*i_ritu;
pos=0;
foreach(char c in i_s)
 {for(kk=0;code39_mozi.Length>kk&&c!=code39_mozi[kk];)kk++;
  if(code39_mozi.Length<=kk)
   {z.err_s="code39 convert error ("+c+")";return false;}
  divi=kk/10;rem=kk%10;
  if(4==divi){bb=0;ss=rem;}else{bb=rem+1;ss=divi+4;}
  for(kk=0;kk<5;kk++)
   {if(0==code39_bar_ixx[bb,kk]){x1+=pos+short_bar2;nxt=short_bar3;i=0;}
    else                        {x1+=pos+long_bar2;nxt=long_bar3;i=1;}
    i_g.DrawLine((Pen)pen_a[i],x1,y1,x1,y2);
    if(0==code39_space_ixx[ss,kk])pos=short_space+nxt;else pos=long_space+nxt;
   }
 }
if(0==(float)out_a[i_i+4])return true;
x1=((float)out_a[i_i+2]+(float)out_a[i_i+5]+i_xx)*i_ritu;
y1=((float)out_a[i_i+1]+(float)out_a[i_i+3]+(float)out_a[i_i+6]+i_yy)*i_ritu;
font_o=new Font(default_font_s,(float)out_a[i_i+4]*i_ritu
  ,FontStyle.Regular,GraphicsUnit.Millimeter);
z.draw_string(i_g,(float)0,i_s,font_o,Brushes.Black,x1,y1);
return true;
}
//*******************( jan )********************************
bool jan(Graphics i_g,float i_xx,float i_yy,float i_ritu,string i_s,int i_i)
{if(TEST_DATA==control)i_s=i_s.PadRight(7,i_s[0]);
if(z.equal(i_s.Length,12,7))i_s+=z.jan(i_s);
if(13!=i_s.Length&&8!=i_s.Length)
  {z.err_s="jan length 8 or 13 error ("+i_s+")";return false;}
short_bar=((float)out_a[i_i]*i_ritu);
pen_a.Clear();pen_a.Add(0);
pen_a.Add(new Pen(solid_brush_o,short_bar));
pen_a.Add(new Pen(solid_brush_o,short_bar*2));
pen_a.Add(new Pen(solid_brush_o,short_bar*3));
pen_a.Add(new Pen(solid_brush_o,short_bar*4));
x1=((float)out_a[i_i+2]+i_xx)*i_ritu;
y1=((float)out_a[i_i+3]+i_yy)*i_ritu;
dd=jan_pt_no=0;
jan_loop:
if(0==dd||7==dd&&13==i_s.Length||4==dd&&8==i_s.Length||i_s.Length==dd)
  {y2=((float)out_a[i_i+3]+(float)out_a[i_i+1]+i_yy)*i_ritu;
   if(i_s.Length==dd)jan_e_fx[1]=x1;
   if(7==dd&&13==i_s.Length||4==dd&&8==i_s.Length){x1+=short_bar;jan_e_fx[0]=x1;}
   x1+=short_bar/2;
   i_g.DrawLine((Pen)pen_a[1],x1,y1,x1,y2);
   x1+=short_bar*2;
   i_g.DrawLine((Pen)pen_a[1],x1,y1,x1,y2);
   x1+=short_bar-short_bar/2;
   if(7==dd&&13==i_s.Length||4==dd&&8==i_s.Length){jan_b_fx[1]=x1;x1+=short_bar;}
  }
if(i_s.Length==dd)goto jan_char;
y2=((float)out_a[i_i+3]+zero_float((float)out_a[i_i+1])
     -(float)out_a[i_i]*7.5f+i_yy)*i_ritu;
if(1==dd&&13==i_s.Length||0==dd)jan_b_fx[0]=x1;
if('0'>i_s[dd]||'9'<i_s[dd])
  {z.err_s="jan convert error txt ("+i_s[dd]+")";return false;}
i=Convert.ToInt32(i_s.Substring(dd,1));
if(0==dd&&13==i_s.Length){jan_pt_no=i;goto jan_jump;}
if(7>dd&&13==i_s.Length||4>dd&&8==i_s.Length)
 {j=dd;if(13==i_s.Length)j--;
  if(1==jan_pt[jan_pt_no,j]){jan_0=0;jan_1=1;jan_2=2;jan_3=3;}
  else                      {jan_0=3;jan_1=2;jan_2=1;jan_3=0;}
  x1+=short_bar*jan_bar[i,jan_0]+short_bar*jan_bar[i,jan_1]/2;
  i_g.DrawLine((Pen)pen_a[jan_bar[i,jan_1]],x1,y1,x1,y2);
  x1+=short_bar*jan_bar[i,jan_1]-short_bar*jan_bar[i,jan_1]/2
     +short_bar*jan_bar[i,jan_2]+short_bar*jan_bar[i,jan_3]/2;
  i_g.DrawLine((Pen)pen_a[jan_bar[i,jan_3]],x1,y1,x1,y2);
  x1+=short_bar*jan_bar[i,jan_3]-short_bar*jan_bar[i,jan_3]/2;
 }
else
 {x1+=short_bar*jan_bar[i,0]/2;
  i_g.DrawLine((Pen)pen_a[jan_bar[i,0]],x1,y1,x1,y2);
  x1+=short_bar*jan_bar[i,0]-short_bar*jan_bar[i,0]/2
     +short_bar*jan_bar[i,1]+short_bar*jan_bar[i,2]/2;
  i_g.DrawLine((Pen)pen_a[jan_bar[i,2]],x1,y1,x1,y2);
  x1+=short_bar*jan_bar[i,2]-short_bar*jan_bar[i,2]/2
          +short_bar*jan_bar[i,3];
 }
jan_jump:
dd++;
goto jan_loop;
jan_char:
if(8==i_s.Length){jan_0=0;jan_1=4;}else{jan_0=1;jan_1=6;}
xxx=(jan_e_fx[0]-jan_b_fx[0])/jan_1;yyy=xxx*2;
if(0>=xxx)xxx=0.1f;
if(0>=yyy)yyy=0.1f;
font_o=new Font(default_font_s,yyy-yyy*0.025f,FontStyle.Regular
  ,GraphicsUnit.Millimeter);
y1=((float)out_a[i_i+3]+zero_float((float)out_a[i_i+1])+i_yy)*i_ritu-xxx;
if(8==i_s.Length)goto jan_8;
x1=((float)out_a[i_i+2]+i_xx)*i_ritu-xxx*1.25f;
z.draw_string(i_g,(float)0,i_s.Substring(0,1),font_o,Brushes.Black,x1,y1);
jan_8:
for(i=0;2>i;i++)
 {x1=jan_b_fx[i]-xxx*0.25f;
  z.draw_string(i_g,(float)0,i_s.Substring(jan_0+jan_1*i,jan_1),font_o,Brushes.Black,x1,y1);
 }
return true;
}
 //=====( csv_split )=====
void csv_split(ref ArrayList o_a,string i_s)
{int i,sta,sw=0;string out_s;o_a.Clear();
for(sta=i=0;;i++)
 {if(i_s.Length<=i||','==i_s[i]&&0==sw)
   {out_s=i_s.Substring(sta,i-sta).Trim();
    if(1<out_s.Length&&'"'==out_s[0]&&'"'==out_s[out_s.Length-1])
      out_s=out_s.Substring(1,out_s.Length-2);
    out_s=out_s.Replace("\"\"","\"");
    o_a.Add(out_s);
    if(i_s.Length<=i)break;
    sta=i+1;
    if(i_s.Length<=sta){o_a.Add("");break;}
    continue;
   }
  if('"'==i_s[i])if(0==sw)sw=1;else sw=0;
 }
}
bool to_float(ArrayList o_a,int i_i,int i_count)
{float f=0;
if(0!=i_count&&0!=(s_a.Count-i_i)%i_count)
 {z.err_s="Count("+s_a.Count+")";return false;}
for(i=i_i;s_a.Count>i;i++)
 {if(!to_float(ref f,(string)s_a[i]))return false;o_a.Add(f);}
return true;
}
bool to_float(ref float f,string i_s)
{if(""==i_s){f=0;return true;}
try{f=(float)Convert.ToDouble(i_s);}
catch(Exception e){z.err_s="("+i_s+")"+e.Message;return false;}
return true;
}
bool to_int(ref int i,string i_s)
{if(""==i_s){i=0;return true;}
try{i=Convert.ToInt32(i_s);}
catch(Exception e){z.err_s="("+i_s+")"+e.Message;return false;}
return true;
}
float zero_float(float i_f){return (0>=i_f?0.1f:i_f);}
protected override void OnClosed(EventArgs e){}
static void Main(string[] arg_sx){Application.Run(new ic_form(arg_sx));}
}
